package com.tptj.demo.hg.extension.button.provider;

import com.fanruan.api.log.LogKit;
import com.fanruan.api.report.SundryKit;
import com.fr.form.ui.Button;
import com.fr.form.ui.Widget;
import com.fr.general.ComparatorUtils;
import com.fr.intelli.record.Focus;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.report.ExtraReportClassManager;
import com.fr.report.fun.ExtensionButtonProvider;
import com.fr.report.fun.impl.AbstractExtensionMenuButton;
import com.fr.stable.StringUtils;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-16
 **/
@EnableMetrics
public class Demo extends AbstractExtensionMenuButton {

    public final static String NAME = "hello";

    public final static String ICON = "com/tptj/demo/hg/extension/button/provider/demo.png";

    public Demo() {
        super(NAME,NAME);
        SundryKit.loadToolbarIcon(NAME, ICON);
    }

    @Override
    public Class<? extends Widget> classForDirectoryButton() {
        return this.getClass();
    }

    @Override
    public String getParentDirectory() {
        return null;
    }

    @Override
    public String getType() {
        return "Hello";
    }

    @Override
    public String getRelatedCheckBoxTitle() {
        return StringUtils.EMPTY;
    }

    private boolean selected = true;


    @Override
    public boolean isSelected() {
        return selected;
    }

    @Override
    public void setSelected(boolean isSelected) {
        this.selected = isSelected;
    }


    @Override
    @Focus(id = "com.tptj.demo.hg.extension.button.provider.v10",text = "extension button provider")
    public Button[] createMenuItems() {
        List list = new ArrayList();
        Set<ExtensionButtonProvider> adapters = ExtraReportClassManager.getInstance().getArray(ExtensionButtonProvider.XML_TAG);
        if (adapters != null) {
            for (ExtensionButtonProvider adapter : adapters) {
                if (adapter.getParentDirectory() != null && ComparatorUtils.equals(this.getType(), adapter.getParentDirectory()) && adapter.isSelected()) {
                    Class export = adapter.classForDirectoryButton();
                    ;
                    try {
                        Button button = (Button) export.newInstance();
                        list.add(button);
                    } catch (InstantiationException e) {
                        LogKit.error(e.getMessage());
                    } catch (IllegalAccessException e) {
                        LogKit.error(e.getMessage());
                    }

                }
            }
        }
        return (Button[]) list.toArray(new Button[list.size()]);
    }

    @Override
    public boolean supportMobile() {
        return false;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof Demo &&
                selected == ((Demo)obj).selected ;
    }

}
