package com.tptj.demo.hg.extension.button.provider;

import com.fr.design.gui.icheckbox.UICheckBox;
import com.fr.general.ComparatorUtils;
import com.fr.general.Inter;
import com.fr.report.ExtraReportClassManager;
import com.fr.report.fun.ExtensionButtonProvider;

import javax.swing.*;
import java.util.ArrayList;
import java.util.Set;

public class DemoPane extends AbstractExportToolBarPane {

	private String[] texts = { "Hello A","Hello B"};
	
	private void initComps(){
		if(boxes == null || boxes.isEmpty()){
			boxes = new ArrayList<UICheckBox>();
			for (String text : texts) {
				UICheckBox box = new UICheckBox(text);
				box.setSelected(true);
				boxes.add(box);
			}
		}
		Set<ExtensionButtonProvider> set = ExtraReportClassManager.getInstance().getArray(ExtensionButtonProvider.XML_TAG);
		for (ExtensionButtonProvider provider : set) {
			providers.add(provider);
		}
	}
	
	@Override
	/**
	 * 待说明
	 */
	public void populate() {
		initComps();
		super.populate();
	}

	@Override
	/**
	 * 待说明
	 */
	public void update() {
		initComps();
		super.update();
	}
	
	/**
	 * 更新面板
	 * @param pane 面板
	 * @return JPanel 面板
	 */
	public JPanel updateCenterPane(JPanel pane) {
		initComps();
		return super.updateCenterPane(pane);
	}

	/**
	 * 是否相等
	 * @param obj 待比较对象
	 * @boolean 是否相等
	 */
	public boolean equals(Object obj){
		return obj instanceof DemoPane &&
				ComparatorUtils.equals(this.texts, ((DemoPane)obj).texts);
	}
}