package com.tptj.demo.hg.extension.button.provider;

import com.fanruan.api.report.SundryKit;
import com.fr.form.ui.Widget;
import com.fr.general.ComparatorUtils;
import com.fr.js.JavaScriptImpl;
import com.fr.report.fun.impl.AbstractExtensionButton;
import com.fr.stable.web.Repository;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLReadable;
import com.fr.stable.xml.XMLableReader;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-16
 **/
public class SubBtnB extends AbstractExtensionButton {
    public final static String NAME = "helloB";

    public final static String ICON = "com/tptj/demo/hg/extension/button/provider/demo.png";

    public SubBtnB() {
        super(NAME,NAME);
        SundryKit.loadToolbarIcon(NAME, ICON);
    }

    @Override
    public Class<? extends Widget> classForDirectoryButton() {
        return this.getClass();
    }

    @Override
    public String getParentDirectory() {
        return "Hello";
    }
    private String title = "Hello B";
    @Override
    public String getType() {
        return title;
    }

    @Override
    public String getRelatedCheckBoxTitle() {
        return title;
    }

    private boolean selected = true;

    @Override
    public boolean isSelected() {
        return selected;
    }

    @Override
    public void setSelected(boolean isSelected) {
        this.selected = isSelected;
    }

    @Override
    protected JavaScriptImpl clickAction(Repository repo ) {
        return new JavaScriptImpl("alert('Hello World! B')");
    }

    @Override
    public boolean supportMobile() {
        return false;
    }

    public void writeXML(XMLPrintWriter writer) {
        writer.startTAG("ExtraButton").attr("ButtonName", "SubBtnB");
        writer.startTAG("Buttons")
                .attr("SubBtnB", selected)
                .end();
        super.writeXML(writer);
        writer.end();
    }

    /**
     * 读取XML
     *
     * @param reader XML读取对象
     */
    public void readXML(XMLableReader reader) {
        if (reader.isChildNode()) {
            String nodeName = reader.getTagName();
            if(nodeName.equals("ExtraButton")){
                if(reader.getAttrAsString("ButtonName", "").equals("SubBtnB")){
                    reader.readXMLObject(new XMLReadable() {
                        @Override
                        public void readXML(XMLableReader reader) {
                            SubBtnB.super.readXML(reader);
                            if (reader.getTagName().equals("Buttons")) {
                                SubBtnB.this.setSelected(reader.getAttrAsBoolean("SubBtnB", true));
                            }
                        }
                    });
                }

            }
            //兼容老的
            if (reader.getTagName().equals("Buttons")) {
                SubBtnB.this.setSelected(reader.getAttrAsBoolean("SubBtnB" , this.isSelected()));
            }
        }
    }

    /**
     * 是否相等
     *
     * @param obj 对象
     * @return 同上
     */
    public boolean equals(Object obj) {
        return obj instanceof SubBtnB && this.selected == ((SubBtnB) obj).selected
                && ComparatorUtils.equals(this.title, ((SubBtnB) obj).title);
    }
}
